#include <gtk/gtk.h>
#include <stdlib.h>
#include <time.h>
#include <cstring>
using namespace std;

GtkWidget *entry;
GtkWidget *window;
GtkWidget *grid4;
GtkWidget *grid3;
GtkWidget *grid2;                                                    //Pointers used for graphics
GtkWidget *grid1;
GtkWidget *button;
GtkWidget *button1;
GtkWidget *button2;
GtkWidget *label,*label1,*label2;

void countunassigned(int a[9][9]);
void findunassignedlocation(int a[9][9],int &row,int &col);
void gen(int a[9][9]);
void del(int a[9][9],int N_del);                                        //Functions used in program
void genloop();
void multiplesol(int a[9][9]);
void nosol();
void ins_checkgrid();
void uneditableall(GtkWidget *grid);
void colourassign();
void colorgenshowsol(int a[9][9]);
void colorgen(int a[9][9]);
void matrixtogrid(int a[9][9],GtkWidget *grid);
void gridtomatrix(int a[9][9],GtkWidget *grid);
void matcpy(int a1[9][9],int a2[9][9]);
void reset_all();

bool solvesudoku(int a[9][9]);
bool checkdel(int i,int j);
bool instantcheck(int a[9][9],int row,int col);
bool initialcheck(int a[9][9]);

static void print1 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"1") ;ins_checkgrid();}
static void print2 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"2") ;ins_checkgrid();}
static void print3 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"3") ;ins_checkgrid();}
static void print4 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"4") ;ins_checkgrid();}
static void print5 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"5") ;ins_checkgrid();}
static void print6 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"6") ;ins_checkgrid();}
static void print7 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"7") ;ins_checkgrid();}
static void print8 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"8") ;ins_checkgrid();}
static void print9 (GtkWidget *widget,gpointer   data){entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"9") ;ins_checkgrid();}
                                                      //Function to reinitialize all matrices to null..
int As[9][9]={0},Ar[9][9]={0},Ag[9][9]={0},Ao[9][9]={0};
int coo_matrix[9][9][2];
int N_checked=0,N_unassignedloc=0,N_sol=0,N_countsol=0;
int cswitch=0;
int N_del;int di=0;
int D[81][2];

static void multipleyes (GtkWidget *widget,gpointer   data)
{matrixtogrid(Ar,grid3);multiplesol(Ar);}

static void multipleno (GtkWidget *widget,gpointer   data)
{for(int i=0;i<9;i++)
{button=gtk_grid_get_child_at(GTK_GRID(grid3),12,coo_matrix[i][0][1]);
 gtk_widget_hide(button);}
button=gtk_grid_get_child_at(GTK_GRID(grid3),0,11);
gtk_widget_hide(button);
button=gtk_grid_get_child_at(GTK_GRID(grid3),9,11);
gtk_widget_show(button);
gtk_widget_hide(label1);gtk_widget_hide(label2);gtk_widget_hide(button1);gtk_widget_hide(button2);
colourassign();
uneditableall(grid3);
}

static void gridsolve (GtkWidget *widget,gpointer   data)  //Function to display the solved sudoku with appropriate colours
{                                                           //                                                 and messages
gridtomatrix(As,grid3);
if(!initialcheck(As)){
label=gtk_grid_get_child_at(GTK_GRID(grid3),0,12);
gtk_label_set_text(GTK_LABEL(label),"INVALID ENTRIES");
const char *format = "<span color=\"RED\" font=\"12\" weight=\"heavy\" >\%s</span>";
  char *markup;
  markup = g_markup_printf_escaped (format, "INVALID ENTRIES");  //If entries are invalid
  gtk_label_set_markup (GTK_LABEL (label), markup);
  g_free (markup);
gtk_widget_show(label);return;
    }
   matcpy(Ar,As);
countunassigned(Ar);
if(N_unassignedloc==0){
label=gtk_grid_get_child_at(GTK_GRID(grid3),0,12);
gtk_label_set_text(GTK_LABEL(label),"ALREADY SOLVED");          //Grid is already solved
const char *format = "<span color=\"DARKGREEN\" font=\"12\" weight=\"heavy\" >\%s</span>";
  char *markup;
  markup = g_markup_printf_escaped (format, "ALREADY SOLVED");
  gtk_label_set_markup (GTK_LABEL (label), markup);
  g_free (markup);
gtk_widget_show(label);
for(int i=0;i<9;i++)
{
    button=gtk_grid_get_child_at(GTK_GRID(grid3),12,coo_matrix[i][0][1]);
    gtk_widget_hide(button);
}
button=gtk_grid_get_child_at(GTK_GRID(grid3),0,11);
gtk_widget_hide(button);
return;
}
N_checked=0;N_sol=0;N_countsol=0;
cswitch=2;
multiplesol(Ar);
}

static void setdifficulty (GtkWidget *widget,gpointer   data)       //Function to display "SET DIFFICULTY" window
{   g_object_ref (grid1);
    gtk_container_remove (GTK_CONTAINER (window), grid1);
    gtk_container_add (GTK_CONTAINER (window), grid2);
    gtk_widget_show_all(window);
}

static void returnwelcome2 (GtkWidget *widget,gpointer   data) //Function that returns from set difficulty window to welcome screen
{   g_object_ref (grid2);
    gtk_container_remove (GTK_CONTAINER (window), grid2);
    gtk_container_add (GTK_CONTAINER (window), grid1);
    gtk_widget_show_all(window);
}

static void returnwelcome3 (GtkWidget *widget,gpointer   data) //Function that returns from solver window to welcome screen
{
    for(int i=0;i<9;i++){
    for(int j=0;j<9;j++){
    entry=gtk_grid_get_child_at (GTK_GRID(grid3),coo_matrix[i][j][0],coo_matrix[i][j][1]);
    gtk_widget_set_sensitive (entry,1);
    gtk_widget_modify_fg (entry, GTK_STATE_NORMAL, NULL);
    }}
    matrixtogrid(Ao,grid3);
    g_object_ref (grid3);
    reset_all();
    gtk_container_remove (GTK_CONTAINER (window), grid3);
    gtk_container_add (GTK_CONTAINER (window), grid1);
    gtk_widget_show_all(window);
}

static void returnwelcome4 (GtkWidget *widget,gpointer   data) //Function that returns from play game window to welcome screen
{   matrixtogrid(Ao,grid4);
    for(int i=0;i<9;i++){
    for(int j=0;j<9;j++){
    entry=gtk_grid_get_child_at (GTK_GRID(grid4),coo_matrix[i][j][0],coo_matrix[i][j][1]);
    gtk_widget_set_sensitive (entry,1);
    gtk_entry_set_progress_fraction (GTK_ENTRY(entry),0);
    gtk_widget_modify_fg (entry, GTK_STATE_NORMAL, NULL);
    }}
    g_object_ref (grid4);
    reset_all();
    gtk_container_remove (GTK_CONTAINER (window), grid4);
    gtk_container_add (GTK_CONTAINER (window), grid1);
    gtk_widget_show_all(window);
}

static void generator (GtkWidget *widget,gpointer   data) //Function to generate grids with a unique solution
{int n;
button=gtk_window_get_focus (GTK_WINDOW(window));
n=strlen(gtk_button_get_label (GTK_BUTTON(button)));
switch(n){
case 9:N_del=43;break;
case 5:N_del=36;break;
case 6:N_del=30;break;
case 4:N_del=25;}
g_object_ref (grid2);
gtk_container_remove (GTK_CONTAINER (window), grid2);
gtk_container_add (GTK_CONTAINER (window), grid4);
gtk_widget_show_all(window);
cswitch=0;
gen(As);
cswitch=1;
genloop();
matcpy(Ar,Ag);
colorgen(Ar);
N_countsol=0;
matrixtogrid(Ar,grid4);
}

static void showsolution (GtkWidget *widget,gpointer   data) //Function to show solution
{
matrixtogrid(As,grid4);
uneditableall(grid4);
for(int i=0;i<9;i++)
{
    button=gtk_grid_get_child_at(GTK_GRID(grid4),12,coo_matrix[i][0][1]);
    gtk_widget_hide(button);
}
colorgenshowsol(Ag);
button=gtk_grid_get_child_at(GTK_GRID(grid4),0,12);
gtk_widget_hide(button);
button=gtk_grid_get_child_at(GTK_GRID(grid4),0,13);
gtk_widget_hide(button);
button=gtk_grid_get_child_at(GTK_GRID(grid4),4,13);
gtk_widget_hide(button);
}

static void givesudoku (GtkWidget *widget,gpointer   data)//Function to take in sudoku for solver
{
g_object_ref (grid1);
gtk_container_remove (GTK_CONTAINER (window), grid1);
gtk_container_add (GTK_CONTAINER (window), grid3);
gtk_widget_show_all(window);
gtk_widget_hide(button1);
gtk_widget_hide(button2);
gtk_widget_hide(label1);
gtk_widget_hide(label2);
button=gtk_grid_get_child_at(GTK_GRID(grid3),0,0);
gtk_window_set_focus (GTK_WINDOW(window),button);
}

static void eraser (GtkWidget *widget,gpointer   data)   //Function for eraser button
{
entry=gtk_window_get_focus (GTK_WINDOW(window));
gtk_entry_set_text (GTK_ENTRY(entry),"") ;
ins_checkgrid();
}

static void finalcheck (GtkWidget *widget,gpointer   data){  //Function for final check button
gridtomatrix(Ar,grid4);bool c=1,d=1;
for(int i=0;i<9;i++)
{
    for(int j=0;j<9;j++)
    {   entry=gtk_grid_get_child_at(GTK_GRID(grid4),coo_matrix[i][j][0],coo_matrix[i][j][1]);
       if(Ar[i][j]!=0)
       {
        if(Ar[i][j]!=As[i][j])
           {
             gtk_entry_set_progress_fraction (GTK_ENTRY(entry),1);d=0;
           }
           else{
            gtk_entry_set_progress_fraction (GTK_ENTRY(entry),0);
            }
       }
       else{gtk_entry_set_progress_fraction (GTK_ENTRY(entry),0);c=0;}
    }
}
if(c&&d){
    label=gtk_grid_get_child_at(GTK_GRID(grid4),0,11);
    gtk_label_set_text(GTK_LABEL(label),"WELL DONE!");
  const char *format = "<span color=\"DARKBLUE\" font=\"12\" weight=\"heavy\" >\%s</span>";
  char *markup;
  markup = g_markup_printf_escaped (format, "WELL DONE!");
  gtk_label_set_markup (GTK_LABEL (label), markup);
  g_free (markup);
}
}

int main (int argc, char *argv[])                                                    //Main function
{
gtk_init (&argc, &argv);

for(int i=0;i<9;i++)
{

    for(int j=0;j<9;j++)
    {
if(i>=0&&i<=2&&j>=0&&j<=2){coo_matrix[i][j][0]=j;coo_matrix[i][j][1]=i;}
if(i>=0&&i<=2&&j>=3&&j<=5){coo_matrix[i][j][0]=j+1;coo_matrix[i][j][1]=i;}
if(i>=0&&i<=2&&j>=6&&j<=8){coo_matrix[i][j][0]=j+2;coo_matrix[i][j][1]=i;}

if(i>=3&&i<=5&&j>=0&&j<=2){coo_matrix[i][j][0]=j;coo_matrix[i][j][1]=i+1;}
if(i>=3&&i<=5&&j>=3&&j<=5){coo_matrix[i][j][0]=j+1;coo_matrix[i][j][1]=i+1;}
if(i>=3&&i<=5&&j>=6&&j<=8){coo_matrix[i][j][0]=j+2;coo_matrix[i][j][1]=i+1;}

if(i>=6&&i<=8&&j>=0&&j<=2){coo_matrix[i][j][0]=j;coo_matrix[i][j][1]=i+2;}
if(i>=6&&i<=8&&j>=3&&j<=5){coo_matrix[i][j][0]=j+1;coo_matrix[i][j][1]=i+2;}
if(i>=6&&i<=8&&j>=6&&j<=8){coo_matrix[i][j][0]=j+2;coo_matrix[i][j][1]=i+2;}
    }
}

window = gtk_window_new (GTK_WINDOW_TOPLEVEL);                  //getting window
gtk_window_set_title (GTK_WINDOW (window), "SUDOKU QUEST");     //Heading for window
gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
g_signal_connect (window, "destroy", G_CALLBACK (gtk_main_quit), NULL);
gtk_container_set_border_width (GTK_CONTAINER (window), 30);
gtk_window_set_default_size (GTK_WINDOW(window), 425, 375);


//--------------------------------------------GRID 1--------------------------------------------------
{
  grid1 = gtk_grid_new ();
  gtk_container_add (GTK_CONTAINER (window), grid1);
  label= gtk_label_new("WELCOME TO SUDOKU QUEST");          //Heading for window
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 0, 10, 1);   //Attaching label
  gtk_widget_set_hexpand (label, TRUE);
  const char *format = "<span color=\"BLUE\" font=\"19\" weight=\"heavy\" >\%s</span>";
  char *markup;
  markup = g_markup_printf_escaped (format, "WELCOME TO SUDOKU QUEST");
  gtk_label_set_markup (GTK_LABEL (label), markup);
  g_free (markup);
  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 1, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

    label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 2, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

    label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 3, 8, 1);      //Empty labels to  make window's appearance better
  gtk_widget_set_hexpand (label, TRUE);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 4, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  button = gtk_button_new_with_label ("SOLVE SUDOKU");        //Button "solve sudoku" added
  g_signal_connect (button, "clicked", G_CALLBACK(givesudoku) , NULL);  //Linking with solver grid
  gtk_grid_attach (GTK_GRID (grid1), button, 4 ,5, 2, 2);

    label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 7, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 8, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  button = gtk_button_new_with_label ("PLAY GAME");                         //Button"play game" added
   g_signal_connect (button, "clicked", G_CALLBACK(setdifficulty) , NULL);  //Linking with set difficulty grid
  gtk_grid_attach (GTK_GRID (grid1), button, 4, 9, 2, 2);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 11, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

    label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid1), label, 0, 12, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  button = gtk_button_new_with_label ("QUIT");        //Button "Quit" added
  g_signal_connect (button, "clicked", G_CALLBACK (gtk_main_quit), NULL);
  gtk_grid_attach (GTK_GRID (grid1), button, 4, 13, 2, 1);
  }

  gtk_widget_show_all (window);


//----------------------------------------------------GRID 2--------------------------------------------------
{
  grid2 = gtk_grid_new ();
  label= gtk_label_new("SELECT DIFFICULTY LEVEL");                 //Label SET DIFFICULTY LEVEL ADDED
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 0, 10, 1);
  gtk_widget_set_hexpand (label, TRUE);
  const char *format = "<span color=\"ORANGE\" font=\"18\" weight=\"heavy\" >\%s</span>";
  char *markup;
  markup = g_markup_printf_escaped (format, "SELECT DIFFICULTY LEVEL");
  gtk_label_set_markup (GTK_LABEL (label), markup);
  g_free (markup);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 1, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

    label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 2, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

    label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 3, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  button = gtk_button_new_with_label ("NIGHTMARE");


  g_signal_connect (button, "clicked", G_CALLBACK(generator) , NULL);



  gtk_grid_attach (GTK_GRID (grid2), button, 4 ,4, 2, 2);

    label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 5, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 6, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  button = gtk_button_new_with_label ("HARD ");
  g_signal_connect (button, "clicked", G_CALLBACK(generator) , NULL);
  gtk_grid_attach (GTK_GRID (grid2), button, 4, 7, 2, 2);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 8, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

    label= gtk_label_new(" ");                                                /*Buttons to select difficulty levels*/
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 9, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

   button = gtk_button_new_with_label ("MEDIUM");
  g_signal_connect (button, "clicked", G_CALLBACK(generator) , NULL);
  gtk_grid_attach (GTK_GRID (grid2), button, 4, 10, 2, 2);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 11, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

    label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 12, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

   button = gtk_button_new_with_label ("EASY");
  g_signal_connect (button, "clicked", G_CALLBACK(generator) , NULL);
  gtk_grid_attach (GTK_GRID (grid2), button, 4, 13, 2, 2);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 14, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 15, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  label= gtk_label_new(" ");
  gtk_grid_attach (GTK_GRID (grid2), label, 0, 16, 8, 1);
  gtk_widget_set_hexpand (label, TRUE);

  button = gtk_button_new_with_label ("BACK");                                //Back button to return to main screen
  g_signal_connect (button, "clicked", G_CALLBACK(returnwelcome2) , NULL);
  gtk_grid_attach (GTK_GRID (grid2), button, 4, 17, 2, 2);


}



//---------------------------------------------------GRID 3------------------------------------------------
{
grid3 = gtk_grid_new ();
gtk_grid_set_row_spacing (GTK_GRID (grid3), 0);
gtk_grid_set_column_spacing (GTK_GRID (grid3), 0);

for(int i=0;i<9;i++)
{
if(i==3){
label= gtk_label_new(" ");
gtk_grid_attach (GTK_GRID (grid3), label, 0, 3, 11, 1);gtk_widget_set_hexpand (label, TRUE);
}
if(i==6){
label= gtk_label_new(" ");                                                                          //Empty labels to make
gtk_grid_attach (GTK_GRID (grid3), label, 0, 7, 11, 1);gtk_widget_set_hexpand (label, TRUE);        //window look attractive
}
for(int j=0;j<9;j++)
{
if(j==2){
label= gtk_label_new("   ");
gtk_grid_attach (GTK_GRID (grid3), label, j+1, coo_matrix[i][j][1], 1, 1);gtk_widget_set_hexpand (label, TRUE);
}
if(j==5){
label= gtk_label_new("   ");
gtk_grid_attach (GTK_GRID (grid3), label, j+2, coo_matrix[i][j][1], 1, 1);gtk_widget_set_hexpand (label, TRUE);
}
if(j==8){
label= gtk_label_new("   ");
gtk_grid_attach (GTK_GRID (grid3), label, j+3, coo_matrix[i][j][1], 1, 1);gtk_widget_set_hexpand (label, TRUE);
}
entry= gtk_entry_new();
gtk_entry_set_width_chars (GTK_ENTRY(entry),1);
gtk_entry_set_max_length (GTK_ENTRY(entry),1);
gtk_grid_attach (GTK_GRID (grid3), entry, coo_matrix[i][j][0],coo_matrix[i][j][1], 1, 1);


gtk_widget_set_hexpand (entry, TRUE);
gtk_entry_set_alignment (GTK_ENTRY(entry),0.5);
gtk_widget_set_vexpand (entry, TRUE);
}
}

{button = gtk_button_new_with_label ("1");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print1),NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 12, 0, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("2");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print2), NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 12, 1, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("3");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print3), NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 12, 2, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("4");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print4), NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 12, 4, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("5");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print5), NULL);     //Numbers defined and their responses after click assigned
gtk_grid_attach (GTK_GRID (grid3), button, 12, 5, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("6");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print6), NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 12, 6, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("7");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print7), NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 12, 8, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("8");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print8), NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 12, 9, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("9");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print9), NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 12, 10, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
}
button = gtk_button_new_with_label ("SOLVE");       //Button solve added
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (gridsolve), NULL);     //Linking the solution with the grid after button click
gtk_grid_attach (GTK_GRID (grid3), button, 0, 11, 8, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("QUIT");                                //Button Quit added
g_signal_connect (button, "clicked", G_CALLBACK (returnwelcome3), NULL);
gtk_grid_attach (GTK_GRID (grid3), button, 8, 11, 3, 1);                    //Linking quit button with the welcome screen
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
}

label1= gtk_label_new("Another Solution Available!");
gtk_grid_attach (GTK_GRID (grid3), label1, 0, 12, 12, 1);gtk_widget_set_hexpand (label1, TRUE);
const char *format = "<span color=\"DARKBLUE\" font=\"10\" weight=\"heavy\" >\%s</span>";
  char *markup;
  markup = g_markup_printf_escaped (format, "Another Solution Available!");//  Dialogue box for confirmation of displaying another
  gtk_label_set_markup (GTK_LABEL (label1), markup);                       //  solution if multiple solutions exist
  g_free (markup);
label2= gtk_label_new("Do You want Another Solution To be Displayed?");
  markup = g_markup_printf_escaped (format, "Do You want Another Solution To be Displayed?");
  gtk_label_set_markup (GTK_LABEL (label2), markup);
  g_free (markup);
gtk_grid_attach (GTK_GRID (grid3), label2, 0, 13, 12, 1);gtk_widget_set_hexpand (label2, TRUE);
button1 = gtk_button_new_with_label ("YES");
g_signal_connect (button1, "clicked", G_CALLBACK (multipleyes), NULL);
gtk_grid_attach (GTK_GRID (grid3), button1, 2, 14, 3, 1);
gtk_widget_set_vexpand (button, TRUE);
button2 = gtk_button_new_with_label ("NO");
g_signal_connect (button2, "clicked", G_CALLBACK (multipleno), NULL);
gtk_grid_attach (GTK_GRID (grid3), button2, 7, 14, 3, 1);
gtk_widget_set_vexpand (button, TRUE);


//-----------------------------------------------------GRID 4-------------------------------------------------------
{
grid4 = gtk_grid_new ();
gtk_grid_set_row_spacing (GTK_GRID (grid4), 0);
gtk_grid_set_column_spacing (GTK_GRID (grid4), 0);
                                                                    //Creating Butons,Entries and Labels for Play Sudoku Window
for(int i=0;i<9;i++)
{
if(i==3){
label= gtk_label_new(" ");
gtk_grid_attach (GTK_GRID (grid4), label, 0, 3, 11, 1);gtk_widget_set_hexpand (label, TRUE);
}
if(i==6){
label= gtk_label_new(" ");
gtk_grid_attach (GTK_GRID (grid4), label, 0, 7, 11, 1);gtk_widget_set_hexpand (label, TRUE);
}
for(int j=0;j<9;j++)
{
if(j==2){
label= gtk_label_new("   ");
gtk_grid_attach (GTK_GRID (grid4), label, j+1, coo_matrix[i][j][1], 1, 1);gtk_widget_set_hexpand (label, TRUE);
}
if(j==5){
label= gtk_label_new("   ");
gtk_grid_attach (GTK_GRID (grid4), label, j+2, coo_matrix[i][j][1], 1, 1);gtk_widget_set_hexpand (label, TRUE);
}
if(j==8){
label= gtk_label_new("   ");
gtk_grid_attach (GTK_GRID (grid4), label, j+3, coo_matrix[i][j][1], 1, 1);gtk_widget_set_hexpand (label, TRUE);
}
entry= gtk_entry_new();
gtk_entry_set_width_chars (GTK_ENTRY(entry),1);
gtk_entry_set_max_length (GTK_ENTRY(entry),1);
gtk_grid_attach (GTK_GRID (grid4), entry, coo_matrix[i][j][0],coo_matrix[i][j][1], 1, 1);
gtk_widget_set_hexpand (entry, TRUE);
gtk_entry_set_alignment (GTK_ENTRY(entry),0.5);
gtk_widget_set_vexpand (entry, TRUE);
}
}
                                                              //Creating Butons for Play Sudoku Window
{button = gtk_button_new_with_label ("1");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print1),NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 0, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("2");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print2), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 1, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("3");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print3), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 2, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("4");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print4), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 4, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("5");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print5), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 5, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("6");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print6), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 6, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("7");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print7), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 8, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("8");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print8), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 9, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("9");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (print9), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 12, 10, 1, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
}

label= gtk_label_new(" ");
gtk_grid_attach (GTK_GRID (grid4), label, 0, 11, 12, 1);gtk_widget_set_hexpand (label, TRUE);

button = gtk_button_new_with_label ("SHOW SOLUTION");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (showsolution), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 0, 12, 11, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("ERASE");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (eraser), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 0, 13, 3, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
button = gtk_button_new_with_label ("CHECK");
gtk_button_set_focus_on_click (GTK_BUTTON(button),0);
g_signal_connect (button, "clicked", G_CALLBACK (finalcheck), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 4, 13, 3, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);

button = gtk_button_new_with_label ("QUIT ");
g_signal_connect (button, "clicked", G_CALLBACK (returnwelcome4), NULL);
gtk_grid_attach (GTK_GRID (grid4), button, 8, 13, 3, 1);
gtk_widget_set_hexpand (button, TRUE);gtk_widget_set_vexpand (button, TRUE);
}
gtk_main ();
return 0;
}

void countunassigned(int a[9][9])              //Counts the number of unassigned locations in a sudoku grid
{
    N_unassignedloc=0;
    for(int row=0;row<9;row++)
    {
        for(int col=0;col<9;col++)
        {
            if((a[row][col])==0) {N_unassignedloc++;}
        }
    }
}


void findunassignedlocation(int a[9][9],int &row,int &col)          //Function to find unassigned locations in a given 9X9 grid
{
    int i,j;
    for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
            if(a[i][j]==0)
            {
                    row=i;
                    col=j;
                    return;
            }
        }
    }
}

void gen(int a[9][9])                               //Function to generate a random 9X9 Sudoku grid
{
    srand(time(NULL));
    int i=0;
    for(;i<9;)
    {
        a[0][i]=rand()%9+1;
        if(instantcheck(a,0,i)){i++;continue;}
        a[0][i]=0;
    }

    countunassigned(a);
    solvesudoku(a);
}

void del(int a[9][9],int Ndel)             //Deletes N_del number of entries from a given matrix randomly
{
   srand(time(NULL));
   di=0;
   matcpy(a,As);
   int i=0,j=0,k=0;
   for(;k<Ndel;)
   {
       i=rand()%9;j=rand()%9;
       if(checkdel(i,j))
       {
           a[i][j]=0;
           k++;
           D[di][0]=i;
           D[di][1]=j;
           di++;
           continue;
       }
   }
}



void genloop()                         //Function to ensure a unquie solution for generated sudoku
{
    N_checked=0;N_sol=0;
    del(Ag,N_del);
    matcpy(Ar,Ag);
    countunassigned(Ar);
    solvesudoku(Ar);
    if(N_sol>1){genloop();}
    return;
}

void multiplesol(int a[9][9])     //Function to check for multiple solutions for the input sudoku
{
    N_sol=0;N_countsol++;N_checked=0;
    matcpy(a,As);
    solvesudoku(a);
    if(N_sol==0){nosol();}
    if(N_sol==1&&N_countsol==1){colourassign();uneditableall(grid3);
                                matrixtogrid(a,grid3);multiplesol(a);}
    if(N_sol==2){
    gtk_widget_show(label1);
    gtk_widget_show(label2);
    gtk_widget_show(button1);
    gtk_widget_show(button2);
    for(int i=0;i<9;i++)
    {
    button=gtk_grid_get_child_at(GTK_GRID(grid3),12,coo_matrix[i][0][1]);
    gtk_widget_hide(button);
    }
    button=gtk_grid_get_child_at(GTK_GRID(grid3),0,11);
    gtk_widget_hide(button);
    button=gtk_grid_get_child_at(GTK_GRID(grid3),9,11);
    gtk_widget_hide(button);
    }
    if(N_sol<N_countsol){gtk_button_clicked(GTK_BUTTON(button2));}
}

void nosol()                    //Function for printing no solution if grid has no solution
{
for(int i=0;i<9;i++)
{
    button=gtk_grid_get_child_at(GTK_GRID(grid3),12,coo_matrix[i][0][1]);
    gtk_widget_hide(button);
}
button=gtk_grid_get_child_at(GTK_GRID(grid3),0,11);
gtk_widget_hide(button);

label=gtk_grid_get_child_at(GTK_GRID(grid3),0,12);
gtk_label_set_text(GTK_LABEL(label),"NO SOLUTION");
const char *format = "<span color=\"DARKGREEN\" font=\"10\" weight=\"heavy\" >\%s</span>";
  char *markup;
  markup = g_markup_printf_escaped (format, "NO SOLUTION");
  gtk_label_set_markup (GTK_LABEL (label), markup);
  g_free (markup);
gtk_widget_show(label);
}

void ins_checkgrid()               //Function to instant check the grid in PLAY GAME and display errors
{
gridtomatrix(Ar,grid4);
for(int i=0;i<9;i++){
for(int j=0;j<9;j++){
if(Ag[i][j]==0&&Ar[i][j]!=0){
        if(!instantcheck(Ar,i,j)){entry=gtk_grid_get_child_at (GTK_GRID(grid4),coo_matrix[i][j][0],coo_matrix[i][j][1]);
        gtk_entry_set_progress_fraction (GTK_ENTRY(entry),1);}
        else{entry=gtk_grid_get_child_at (GTK_GRID(grid4),coo_matrix[i][j][0],coo_matrix[i][j][1]);
        gtk_entry_set_progress_fraction (GTK_ENTRY(entry),0);}
}
if(Ar[i][j]==0){entry=gtk_grid_get_child_at (GTK_GRID(grid4),coo_matrix[i][j][0],coo_matrix[i][j][1]);
        gtk_entry_set_progress_fraction (GTK_ENTRY(entry),0);}
}}}

void uneditableall(GtkWidget *grid)     //Makes all the entries uneditable
{
    for(int i=0;i<9;i++)
    {
        for(int j=0;j<9;j++)
        {
            entry=gtk_grid_get_child_at(GTK_GRID(grid),coo_matrix[i][j][0],coo_matrix[i][j][1]);
            gtk_entry_set_progress_fraction(GTK_ENTRY(entry),0);
            gtk_widget_set_sensitive(entry,0);

        }
    }
}

void colourassign()                  //Changes colour of entries in Sudoku solver
{
    for(int i=0;i<9;i++)
    {
        for(int j=0;j<9;j++)
        {
            entry=gtk_grid_get_child_at(GTK_GRID(grid3),coo_matrix[i][j][0],coo_matrix[i][j][1]);
            GdkRGBA color2={0,0,51,1};GdkRGBA color3={255,0,0,1};
            if(As[i][j]!=0){
            gtk_widget_override_color (entry,GTK_STATE_FLAG_NORMAL,&color2);}
            else{gtk_widget_override_color (entry,GTK_STATE_FLAG_NORMAL,&color3);}
        }
    }
}

void colorgenshowsol(int a[9][9])     //Assigns colours to entries while displaying solution in Play game
{

  for(int i=0;i<9;i++){
    for(int j=0;j<9;j++)
    {   if(a[i][j]==0)
    {
        entry=gtk_grid_get_child_at (GTK_GRID(grid4),coo_matrix[i][j][0],coo_matrix[i][j][1]);
        GdkRGBA color1={255,0,0,1};
        gtk_widget_override_color (entry,GTK_STATE_FLAG_NORMAL,&color1);
    }
    }
  }
}

void colorgen(int a[9][9])     //Changes colour of grid in while displaying generated sudoku
{

  for(int i=0;i<9;i++){
    for(int j=0;j<9;j++)
    {   if(a[i][j]!=0)
    {
        entry=gtk_grid_get_child_at (GTK_GRID(grid4),coo_matrix[i][j][0],coo_matrix[i][j][1]);
        GdkRGBA color1={0,0,51,1};
        gtk_widget_override_color (entry,GTK_STATE_FLAG_NORMAL,&color1);
        gtk_widget_set_sensitive (entry,FALSE);
    }
    }
  }
}

void matrixtogrid(int a[9][9],GtkWidget *grid)  //Function to output entries in grid from the matrix
{
    for(int i=0;i<9;i++)
    {
        for(int j=0;j<9;j++)
        {
            entry=gtk_grid_get_child_at (GTK_GRID(grid),coo_matrix[i][j][0],coo_matrix[i][j][1]);
            switch (a[i][j]){
            case 0:gtk_entry_set_text (GTK_ENTRY(entry),"");break;
            case 1:gtk_entry_set_text (GTK_ENTRY(entry),"1");break;
            case 2:gtk_entry_set_text (GTK_ENTRY(entry),"2");break;
            case 3:gtk_entry_set_text (GTK_ENTRY(entry),"3");break;
            case 4:gtk_entry_set_text (GTK_ENTRY(entry),"4");break;
            case 5:gtk_entry_set_text (GTK_ENTRY(entry),"5");break;
            case 6:gtk_entry_set_text (GTK_ENTRY(entry),"6");break;
            case 7:gtk_entry_set_text (GTK_ENTRY(entry),"7");break;
            case 8:gtk_entry_set_text (GTK_ENTRY(entry),"8");break;
            case 9:gtk_entry_set_text (GTK_ENTRY(entry),"9");break;
            }
        }
    }
}

void gridtomatrix(int a[9][9],GtkWidget *grid)    //Function to read entries from the grid and store in matrix
{
    const char *c;int n;
    for(int i=0;i<9;i++)
    {
        for(int j=0;j<9;j++)
        {
            entry=gtk_grid_get_child_at (GTK_GRID(grid),coo_matrix[i][j][0],coo_matrix[i][j][1]);
            c=gtk_entry_get_text (GTK_ENTRY(entry));
            if(*(c)=='1'||*(c)=='2'||*(c)=='3'||*(c)=='4'||*(c)=='5'||*(c)=='6'||*(c)=='7'||*(c)=='8'||*(c)=='9')
                {sscanf(c,"%1d",&n);a[i][j]=n;}
            else{a[i][j]=0;}
        }
    }
}

void matcpy(int a1[9][9],int a2[9][9])              //Function to copy Matrix a2 to Matrix a1
{
    for(int i=0;i<9;i++)
    {
        for(int j=0;j<9;j++)
        {
            a1[i][j]=a2[i][j];
        }
    }
}

void reset_all()                         //Function to reinitialize all matrices to null..
{
matcpy(As,Ao);
matcpy(Ag,Ao);
matcpy(Ar,Ao);
N_checked=0;N_unassignedloc=0;N_sol=0;N_countsol=0;
cswitch=0;
N_del=0;di=0;
}

bool solvesudoku(int a[9][9])                      //Function to solve a given sudoku grid
{
    int row,col;
    row=-1;col=-1;
    findunassignedlocation(a,row,col);
    if(row==-1){return true;}
    for(int i=1;i<=9;i++)
    {
        a[row][col]=i;
        if(instantcheck(a,row,col))
        {
            N_checked++;
            if(N_checked==N_unassignedloc)
                {
                    if(cswitch==0){return true;}                               //A variable cswitch is used to switch
                    if(cswitch==1){N_sol++;if(N_sol==2){return true;}}         //between functionalities of solvesudoku function
                    if(cswitch==2){N_sol++;if(N_sol==N_countsol){return true;}}
                }
            else{if(solvesudoku(a))
                return true; }
            N_checked--;
        }
        a[row][col]=0;
    }
    return false;
}

bool checkdel(int i,int j)            //Function to prevent repitions in deleting entries
{
    for(int k=0;k<di;k++)
    {
        if(D[k][0]==i&&D[k][1]==j){return 0;}
    }
    return 1;
}

bool instantcheck(int a[9][9],int row,int col)             //Checks for repitition in row,column and 3X3 square
{
    int i,j;
    for(i=0;i<9;i++)
    {
        if(i!=row)
        {
            if(a[i][col]==a[row][col])
                return false;
        }
    }

    for(i=0;i<9;i++)
    {
        if(i!=col)
        {
            if(a[row][i]==a[row][col])
                return false;
        }
    }

    for(i=0;i<3;i++)
    {
        for(j=0;j<3;j++)
        {
            if(i+(row-(row%3))!=row||j+(col-(col%3))!=col)
            {
                if(a[i+(row-(row%3))][j+(col-(col%3))]==a[row][col])
                    return false;
            }

        }
    }
  return true;
}

bool initialcheck(int a[9][9])         //Function to Checks for repitition in row,column and 3X3 square initially
{
    for(int row=0;row<9;row++)
    {
        for(int col=0;col<9;col++)
        {
            if(a[row][col]!=0)
                {if(!instantcheck(a,row,col)) return false;}
        }
    }
    return true;
}
